<?php
// Copyright (c) 2005, RedIRIS. All Rights Reserved.
//
// You may distribute under the terms of the GNU General Public License,
// as specified in the LICENSE file that was shipped with this distribution

class PoA {
  
var $local_site;
var $cfg; // Configuration parameters
var $config_file;

function PoA($local_site)
{
 $this->local_site = $local_site;
}

// Taken from php.net to replace php 5 functions
function __http_build_query($formdata,$numeric_prefix)
{
 if (!function_exists('http_build_query'))
	{$arr = array();
	 foreach ($formdata as $key => $val)
	 $arr[] = urlencode($numeric_prefix.$key)."=".urlencode($val);
	 return implode($arr, "&");
	}
 else 	{return http_build_query($formdata,$numeric_prefix);}
}


function check_Access()
{

include 'crypt.php';

// Get config file name from php.ini
$phpPoA_ini_file = "/var/www/consigna/papi/phpPoA.ini";

ob_start();
$this->set_Global_Parameters($phpPoA_ini_file);

// Get the Simetric Key lkey
$fp1=fopen($this->cfg["LKEY_File"],"r");
$lkey=fread($fp1,8192);
fclose($fp1);

// Get the Public Key
$fp2=fopen($this->cfg["GPoA_Pub_Key"],"r");
$pub_key=fread($fp2,8192);
fclose($fp2);

$action = array_key_exists('ACTION',$_REQUEST) ? $_REQUEST['ACTION'] : "";



if ($action == "CHECKED")
{

///////////////////////////////////////////
//                                       //
//            GpoA Response              //
//                                       //
///////////////////////////////////////////


 $data = $_REQUEST['DATA'];

 list ($valid, $key, $userAssertion) = $this->test_GpoA_Response($data,$pub_key);

 if ($valid)
 {// GpoA has validated the request

// Check the filters

if ( !$this->test_Filters($userAssertion) )
 {// The user does not match with the filters
  $error_message = date("d-M-Y H:i:s")." ".$this->local_site.": The user $userAssertion does not match with the filters";
  error_log ($error_message."\n", 3,$this->cfg["error_log"]);

$this->final_Action(0,$userAssertion,"Location: ".$this->cfg['Not_Auth_Error_File']);

 }

 // The user matches with the filters: Set the cookie Lcook and allow access

  $Lcook_cookie = $this->gen_Lcook($userAssertion,$lkey);
  
  if (setcookie ( "Lcook" , $Lcook_cookie , false , $this->cfg["Location"] , $this->cfg["Cookie_Domain"], 0))
   {

if ($key != "DUMMY")
{ // POST Method: Reload the original request
   
   $req_s = $this->load_Request($key);
   $req = unserialize($req_s);
   if (!$req_s) 
      {
      $error_message = date("d-M-Y H:i:s")." ".$this->local_site.": Has not been possible reload the original request. Do not allow access";
      error_log ($error_message."\n", 3,$this->cfg["error_log"]);
      $this->final_Action(0,$userAssertion,"Location: ".$this->cfg['System_Error_File']);
      }

     
   $this->delete_Request($key);
      
	// Reload the PHP parameters of the original request
   	foreach ($req as $index => $value)
   	{
   
    	switch ($index) {
    	case "SERVER":
		$_SERVER = $value;
	   	break;
    	case "POST":
		$_POST = $value;
	   	break;
    	case "FILES":
		$_FILES = $value;
	   	break;
    	case "COOKIE":
		$_COOKIE = $value;
	   	break;
    		       }
   	}


	// Reload the Apache environment of the original request
	$apache_env = array	("QUERY_STRING","REMOTE_ADDR","REMOTE_PORT","REQUEST_METHOD","REQUEST_URI","HTTP_ACCEPT","HTTP_ACCEPT_ENCODING","HTTP_ACCEPT_LANGUAGE","HTTP_CONNECTION","HTTP_HOST","HTTP_REFERER","HTTP_USER_AGENT","DOCUMENT_NAME","DOCUMENT_URI");
	reset ($apache_env);

	foreach ($apache_env as $value)
   	{
	apache_setenv($value, $_SERVER[$value]);
	}



} // $key != "DUMMY"


// $this->final_Action(1,$userAssertion,'Location: '.$location);
return array (1,$userAssertion);


   }
  else
   {
   // Cookie has not been sent OK
   $error_message = date("d-M-Y H:i:s")." ".$this->local_site.": Cookie has not been sent OK.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   $this->final_Action(0,$userAssertion,"Location: ".$this->cfg['Cookie_Error_File']);
   }
     
 }
 else
 {// GpoA has not validated the request. Do not allow access and send ERROR page.
  $error_message = date("d-M-Y H:i:s")." ".$this->local_site.": GpoA has not validated the request. Do not allow access and send ERROR page.";
  error_log ($error_message."\n", 3,$this->cfg["error_log"]);
  $this->final_Action(0,$userAssertion,"Location: ".$this->cfg['Not_Auth_Error_File']);
 }

  
}
else
{ 

///////////////////////////////////////////
//                                       //
// Direct Access from the client browser //
//                                       //
///////////////////////////////////////////

// Get cookie
$Lcook = array_key_exists('Lcook',$_COOKIE) ? $_COOKIE['Lcook'] : "";

if ($Lcook == "")
   {// There is no cookie called Lcook.


if ($_SERVER['REQUEST_METHOD'] == "POST")
{ // Store request parameters in DB

	$req['SERVER']=$_SERVER;
	$req['POST']=$_POST;
	$req['FILES']=$_FILES;
	$req['COOKIE']=$_COOKIE;

	$req_s = serialize($req);
	list ($id,$key) = $this->save_Request($req_s);
	if (!$id) {
		$error_message = date("d-M-Y H:i:s")." ".$this->local_site.": Has not been possible store the original request. Do not allow access";
		error_log ($error_message."\n", 3,$this->cfg["error_log"]);
		$this->final_Action(0,$userAssertion,"Location: ".$this->cfg['System_Error_File']);
		}


}
else
{ // $_SERVER['REQUEST_METHOD'] == "GET"

 $key = 'DUMMY';

}
	if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') { $protocol = 'https://'; }
	else { $protocol = 'http://'; }

	$PoAURL = $protocol.$_SERVER['SERVER_NAME'].":".$_SERVER['SERVER_PORT'].$_SERVER['REQUEST_URI'];
	$parameters = array('ACTION'=>'CHECK','DATA'=>$key,'URL'=>$PoAURL,);
  
	// Request to GpoA
	$request = $this->cfg["GPoA_URL"].'?'.$this->__http_build_query($parameters,"");
	header("Location: $request");
	exit;

} // if ($Lcook == "")
else
   {// Check if Lcook is correct
   list ($res, $userAssertion) = $this->test_Lcook($Lcook,$lkey);

switch ($res) {
   case 0:
    	// User not authorized
	$error_message = date("d-M-Y H:i:s")." ".$this->local_site.": User not authorized.";
    	error_log ($error_message."\n", 3,$this->cfg["error_log"]);
	$this->final_Action(0,$userAssertion,"Location: ".$this->cfg['Not_Auth_Error_File']);
        break;
   case 1:
     	// Cookie Lcook is correct: Update de cookie
     	$Lcook_cookie = $this->gen_Lcook($userAssertion,$lkey);
     	if (setcookie ( "Lcook" , $Lcook_cookie , false , $this->cfg["Location"] , $this->cfg["Cookie_Domain"], 0))
      	{
      	return array (1,$userAssertion);
      	}
     	else
      	{
      	// Cookie has not been updated OK
      	$error_message = date("d-M-Y H:i:s")." ".$this->local_site.": Cookie has not been updated OK.";
      	error_log ($error_message."\n", 3,$this->cfg["error_log"]);
	$this->final_Action(0,$userAssertion,"Location: ".$this->cfg['Cookie_Error_File']);      
       	}
        break;
   case 2:
	// Lcook has expired: Request to GpoA

	if ($_SERVER['REQUEST_METHOD'] == "GET")
	{
	        $key='DUMMY';
	}

   	$PoAURL = "http://".$_SERVER['SERVER_NAME'].":".$_SERVER['SERVER_PORT'].$_SERVER['REQUEST_URI'];
   	$parameters = array('ACTION'=>'CHECK','DATA'=>$key,'URL'=>$PoAURL,);
   	$request = $this->cfg["GPoA_URL"].'?'.$this->__http_build_query($parameters,"");

   	header("Location: $request");
	exit;
        break;
		} // Switch

} // else ($Lcook != "")

} // else ($action != "CHECKED")

ob_end_flush();
} // Function check_Access


function gen_Lcook($userAssertion,$lkey)
{

$Timestamp=time();

$content = "abcd:$Timestamp:".$this->cfg["Location"].":".$this->local_site.":$userAssertion";
  
$Lcook = encrypt_AES($content,$lkey);

return "$Lcook";
}


function test_Lcook($Lcook,$lkey)
{
// Return:
// - 0: Lcook not valid.
// - 1: Lcook valid.
// - 2: Lcook expired.

$newsource = decrypt_AES($Lcook,$lkey);

$newsource = substr ($newsource, 5);
$Lcook = explode (":",$newsource,4);

$timestamp = $Lcook[0];
$loc = $Lcook[1];
$serv = $Lcook[2];
$userAssertion = $Lcook[3]; // Code parameter of the Lcook is the userAssertion

// Check the cookie
if ($userAssertion == "")
{
 $error_message = date("d-M-Y H:i:s").". test_Lcook() Function. ".$this->local_site.": Code parameter of Lcook is empty.";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (0,"0");
}

if ($loc != $this->cfg["Location"])
{
 $error_message = date("d-M-Y H:i:s").". test_Lcook() Function. ".$this->local_site.": Location parameter of Lcook is not valid: $loc";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (0,"$userAssertion");
}

if ($serv != $this->local_site)
{
 $error_message = date("d-M-Y H:i:s").". test_Lcook() Function. ".$this->local_site.": Service_ID parameter of Lcook is not valid: $serv";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (0,"$userAssertion");
}

$now=time();

if ($timestamp + $this->cfg["Lcook_Timeout"] < $now)
{
 $error_message = date("d-M-Y H:i:s").". test_Lcook() Function. ".$this->local_site.": Lcook expired for Code $userAssertion.";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (2,"$userAssertion");
}

if ( $this->test_Filters($userAssertion) )
 {
  return array (1,"$userAssertion");
 }
 else
 {
  $error_message = date("d-M-Y H:i:s").". test_Lcook() Function. ".$this->local_site.": Code $userAssertion matches rejection cookie filter.";
  error_log ($error_message."\n", 3,$this->cfg["error_log"]);
  return array (0,"$userAssertion");
 }


}


function test_Filters($userAssertion)
{

// Main filter
$accept = $this->config_file["PAPI_Main"]["PAPI_Filter_accept"];
$reject = $this->config_file["PAPI_Main"]["PAPI_Filter_reject"];

$main_match = $this->match_Filters($userAssertion,$accept,$reject);

// Local filter
$accept = $this->cfg["PAPI_Filter_accept"];
$reject = $this->cfg["PAPI_Filter_reject"];

$local_match = $this->match_Filters($userAssertion,$accept,$reject);

// Global evaluation
if ($local_match && $main_match)
 {
  return 1;
 }
 else
 {
  $error_message = date("d-M-Y H:i:s").". test_Filters() Function. ".$this->local_site.": Code $userAssertion matches rejection cookie filter.";
  error_log ($error_message."\n", 3,$this->cfg["error_log"]);
  return 0;
 }

}



function match_Filters($userAssertion,$accept,$reject)
{

// If there are no filters,
// a implicit reject filter is defined: $reject == ".*"

if ($accept == "" and $reject == "" )
 {
  return 0;
 }
elseif ($reject == "")
 {// Accept
  	if (preg_match('/'.$accept.'/',$userAssertion))
	 {
	  return 1;
	 }
 }
else // $reject is not NULL
 {
  // Accept
  if ( $accept != "" ) {
	if (preg_match('/'.$accept.'/',$userAssertion))
	 {
	  return 1;
	 }
    }

  // Reject
	if (preg_match('/'.$reject.'/',$userAssertion))
	 {
	  $error_message = date("d-M-Y H:i:s").". match_Filters() Function. ".$this->local_site.": Code $userAssertion matches rejection cookie filter.";
          error_log ($error_message."\n", 3,$this->cfg["error_log"]);
	  return 0;
	 }
 }

$error_message = date("d-M-Y H:i:s").". test_Filters() Function. ".$this->local_site.": Code $userAssertion matches rejection cookie filter.";
error_log ($error_message."\n", 3,$this->cfg["error_log"]);
return 0;
}


function test_GpoA_Response($data,$pub_key)
{

$data = base64_decode($data);
 
// Decrypt the text 
if (!openssl_public_decrypt($data,$newsource,$pub_key)) {
    // Cannot decrypt!
    $error_message = date("d-M-Y H:i:s").". test_GpoA_Response() Function.  ".$this->local_site.": Cannot decrypt response, check GPoA public key.";
    error_log ($error_message."\n", 3,$this->cfg["error_log"]);
    return array (0,null,null);
}  
$response = explode (":",$newsource);

$userAssertion = $response[0];
$key = $response[3];

if($response[0] == "ERROR")
{ // The cookie is not valid. Not authorized User.
 $error_message = date("d-M-Y H:i:s").". test_GpoA_Response() Function. ".$this->local_site.": The cookie is not valid. User not authorized.";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (0,"$key","$userAssertion");
}
else
{ // Check the response (KEY,expiryTime,filters)

$expiryTime = $response[1];
$currentTime = $response[2];

// Check the cookie
if ($userAssertion == "")
{
 // userAssertion is empty
 $error_message = date("d-M-Y H:i:s").". test_GpoA_Response() Function. ".$this->local_site.": userAssertion is empty.";
 error_log ($error_message."\n", 3,$this->cfg["error_log"]);
 return array (0,"$key","$userAssertion");
}
else
{

// Check if the returned key from the GpoA is stored in the DataBase
if ($key != "DUMMY")
{
$id = dba_open($this->cfg["Request_DB"], "r", $this->cfg['DB_Type']);

if (!$id)
 {
   $error_message = date("d-M-Y H:i:s").". test_GpoA_Response() Function. ".$this->local_site.": dba_open $this->cfg[Request_DB] failed.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   return array (0,"$key","$userAssertion");
 }
elseif ( !(dba_exists($key,$id)) )
     {
     // Key $key does not exist in Data Base $cfg[Req_DB]
     $error_message = date("d-M-Y H:i:s").". test_GpoA_Response() Function. ".$this->local_site.": Key $key does not exist in Data Base $this->cfg[Request_DB].";
     error_log ($error_message."\n", 3,$this->cfg["error_log"]);
     return array (0,"$key","$userAssertion");
     }
 }

} // $key != "DUMMY"

return array (1,"$key","$userAssertion");
} // Check the response (KEY,expiryTime,filters)


} // test_GpoA_Response Function


// DBM functions
function save_Request($req)
{

// If the DB does not exist, is created.
$id = dba_open($this->cfg["Request_DB"], "c", $this->cfg['DB_Type']);

if (!$id)
 {
   $error_message = date("d-M-Y H:i:s").". save_Request() Function. ".$this->local_site.": dba_open $this->cfg[Request_DB] failed.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   return array ($id,"");
 }

$key = mt_rand();

dba_replace($key, $req, $id);
dba_close($id);

return array ($id,$key);
}


function load_Request($key)
{

$id = dba_open($this->cfg["Request_DB"], "r", $this->cfg['DB_Type']);

if (!$id)
 {
   $error_message = date("d-M-Y H:i:s").". load_Request() Function. ".$this->local_site.": dba_open $this->cfg[Request_DB] failed.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   return "";
 }

if (dba_exists($key, $id)) {
   $req = dba_fetch($key, $id);
}

dba_close($id);

return $req;
}


function delete_Request($key)
{

$id = dba_open($this->cfg["Request_DB"], "c", $this->cfg['DB_Type']);

if (!$id)
 {
   $error_message = date("d-M-Y H:i:s").". delete_Request() Function. ".$this->local_site.": dba_open $this->cfg[Request_DB] failed.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   dba_close($id);
   return 0;
 }

if (dba_exists($key, $id))
 {
   dba_delete($key, $id);
 }
else
 {
   $error_message = date("d-M-Y H:i:s").". delete_Request() Function. ".$this->local_site.": Key $key does not exist.";
   error_log ($error_message."\n", 3,$this->cfg["error_log"]);
   dba_close($id);
   return 0;
 }
 
dba_close($id);
return 0;
}


function set_Global_Parameters($phpPoA_ini_file)
{

// Get parameters from config file
$this->config_file = parse_ini_file($phpPoA_ini_file, true);

// PAPI_Main Section
$MAIN_Params = Array( "Lcook_Timeout" , "Request_DB" , "DB_Type" , "error_log" , "Not_Auth_Error_File" , "Cookie_Error_File" , "System_Error_File" , "PAPI_Filter_accept" , "PAPI_Filter_reject" , "Cookie_Domain" , "LKEY_File" , "GPoA_Pub_Key" , "GPoA_URL" );

if (!isset($this->config_file["PAPI_Main"]["Cookie_Domain"]))
	{$this->config_file["PAPI_Main"]["Cookie_Domain"] = $_SERVER["SERVER_NAME"];}

foreach ( $MAIN_Params as $param ) {
    $this->cfg[$param] = $this->config_file["PAPI_Main"][$param];
    }

// The parameters in local section of phpPoA_ini_file have priority over parameters in the PAPI_Main section with the same name. Therefore the local parameters set their own value over global parameters. As the filter parameters must not have priority because we have to check both of them, to access PAPI_Filter_accept and PAPI_Filter_reject from PAPI_Main Section we have to use:
// $config_file["PAPI_Main"]["PAPI_Filter_accept"]
// $config_file["PAPI_Main"]["PAPI_Filter_reject"]
// instead of $cfg.


// PAPI_Local Section
$LOCAL_Params = Array( "Location" , "Cookie_Domain" , "LKEY_File" , "GPoA_Pub_Key" , "GPoA_URL" , "PAPI_Filter_accept" , "PAPI_Filter_reject" , "Lcook_Timeout" , "Request_DB" , "DB_Type" , "error_log" , "Not_Auth_Error_File" , "Cookie_Error_File" , "System_Error_File" );

if (!isset($this->config_file[$this->local_site]["Cookie_Domain"]))
	{$this->config_file[$this->local_site]["Cookie_Domain"] = $_SERVER["SERVER_NAME"];}

foreach ( $LOCAL_Params as $param ) {
    if (isset($this->config_file[$this->local_site][$param]))
	{
    	$this->cfg[$param] = $this->config_file[$this->local_site][$param];
    	}
    else{
	$error_message = date("d-M-Y H:i:s").". set_Global_Parameters() Function. ".$this->local_site.": Parameter $param in $this->local_site does not exist.";
	error_log ($error_message."\n", 3,$this->cfg["error_log"]);
	}

    }

} // set_Global_Parameters()


function final_Action($code,$userAssertion,$final_string)
{
	header($final_string);
	exit;
}

} // Class PoA



// Class autoPoA
class autoPoA extends PoA {

 function autoPoA($local_site)
 {
  parent::PoA($local_site);
 }

 function final_Action($code,$userAssertion,$final_string)
 {
  return array ($code,$userAssertion);
 }

}


?>
